<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE article PUBLIC "-//OASIS//DTD DocBook XML V4.2//EN"
"http://www.oasis-open.org/docbook/xml/4.2/docbookx.dtd">
<article lang="es">
  <articleinfo>
    <title>Configurando una interfaz Ethernet como enlace VLAN trunk 802.1q en sistemas GNU/Linux
    </title>
    <authorgroup>
      <author>
        <firstname>Jorge Armando</firstname>
        <surname>Medina</surname>
        <affiliation>
          <orgname>KronOps</orgname>
          <orgdiv>Ingenieria</orgdiv>
        </affiliation>
      </author>
    </authorgroup>
    <pubdate><?dbtimestamp format="Y/m/d"?></pubdate>
    <copyright>
      <year>2021</year>
      <holder>Jorge Armando Medina</holder>
    </copyright>
    <legalnotice>
      <para>Se otorga permiso para copiar, distribuir y/o modificar éste documento bajo los
        términos de la Licencia de Documentación Libre GNU, Versión 1.2 o cualquier otra
        posterior publicada por la Fundación de Software Libre; sin secciones invariantes,
        sin textos en portada y contraportada. Una copia de la licencia se incluye en la
        sección titulada <quote><ulink url="GnuCopyright.htm">Licencia de Documentación
        Libre GNU</ulink></quote>.</para>
    </legalnotice>

    <keywordset>
      <keyword>manual</keyword>

      <keyword>como</keyword>

      <keyword>howto</keyword>

      <keyword>guia</keyword>

      <keyword>tutorial</keyword>

      <keyword>español</keyword>

      <keyword>linux</keyword>

      <keyword>vlan</keyword>

      <keyword>trunk</keyword>

      <keyword>802.1q</keyword>

      <keyword>vlan routing</keyword>
    </keywordset>

    <abstract>
      <para>En este documento se describen los procedimientos para instalar y configurar el soporte
        VLAN <emphasis>IEEE 802.1a</emphasis> en sistemas GNU/Linux, veremos como configurar un
        enlace troncal (<foreignphrase>trunk link</foreignphrase>) y permitir la multiplexión de
        varias VLAN a través de un solo enlace, en este caso una interfaz Ethernet. La separación
        lógica se realiza en un switch Layer 2 con soporte VLAN y la comunicación entre las VLANs
        se realiza a través de un router con soporte VLAN.</para>
    </abstract>
  </articleinfo>

  <section>
    <title>Introducción</title>

    <para>En los entornos de red actuales es necesario que las herramientas tecnologicas que
      usemos para administrar la red sean flexibles y se adapten a los cambios dinámicos del
      crecimiento de la red, una de las técnicas más usadas en la administración de redes es
      la segmentación de grupos de trabajo de red en diferentes dominios de broadcast, normalmente
      cada grupo de trabajo conectado a un switch físico independiente y para que las redes
      separadas se puedan comunicar se utilizan routers.</para>

    <para>En la actualidad los switches "administrables" permite la separación de múltiples redes
      LAN de forma lógica, es decir, dentro de un mismo dispositivo físico es posible crear
      múltiples redes LAN virtuales o VLAN, básicamente los paquetes son separados y distinguidos
      por una etiqueta en la trama Ethernet, el protocolo IEEE 802.1q es el estandar que permite el
      etiquetado de tramás, en los switches se asignan las etiquetas de la VLAN a los puertos,
      hay puertos en modo acceso los cuales permiten conectar un sistema de forma transparente
      y el switch realiza el etiquetado con el ID de la VLAN asignado, también existen los puertos
      troncales o port trunks los cuales tienen la capacidad de transportar tráfico de red de
      diferentes VLANs, normalmente este es un puerto Ethernet con soporte VLAN 802.1q que a
      través de un driver del SO permite la creación de sub interfaces de red en las cuales se
      etiqueta el tráfico con el ID de las VLAN configuradas. Los puertos trunk son normalmente
      utilizados en routers de VLANs los cuales permiten la comunicación entre las diferentes
      redes lógicas, el enrutado se realiza en la capa 3 del modelo OSI, en este caso a nivel IP.
      Hasta hace poco estos routers de VLAN eran dispositivos de red "especializados" de "marca"
      y con sistemas operativos privativos, aquí les vengo a mostrar como configurar un sistema
      GNU/Linux con soporte VLAN 802.1q para realizar el enrutado de múltiples redes VLAN.</para>

    <para>En este documento se describen los procedimientos para instalar y configurar el soporte
      VLAN <emphasis>IEEE 802.1a</emphasis> en sistemas GNU/Linux, veremos como configurar un
      enlace troncal (<foreignphrase>trunk link</foreignphrase>) y permitir la multiplexión
      de varias VLAN a través de un solo enlace, en este caso una interfaz Ethernet. La separación
      lógica se realiza en un switch Layer 2 con soporte VLAN y la comunicación entre las VLANs
      se realiza a través de un router con soporte VLAN.</para>

    <para>La implementación del router la realizaremos en un sistema GNU/Linux, específicamente
      la distribución Rasberry Pi OS, aunque en este documento solo se describen los pasos para
      configurar el enrutado básico es importante hacer saber que el kernel Linux incluye el
      soporte para realizar varias operaciones relacionadas al tráfico de red, por ejemplo,
      NAT, Stateful packet Filtering y QoS entre otras cosas.</para>

    <para>La configuración aquí descrita servirá como la base de una instalación de red simple,
      solo use este ejemplo como base para la implementación de acuerdo a los requerimientos
      de su entorno de red.</para>
  </section>

  <section>
    <title>Descripción de la red basada en VLANs y router GNU/Linux</title>

    <para>El esquema de red basado en VLANs propone la separación de la red de la empresa
      ficticia Example en diferentes subredes aisladas una de otra, la separación será lógica,
      agruparemos diferentes grupos de trabajo, comunidades de usuarios o aplicaciones en
      diferentes redes LAN virtuales o VLAN.</para>

    <para>Cada red tendrá asignado una subred IP diferente, esto permitirá tener mayor control
      en el tráfico y una reducción de tráfico broadcast en la red. El tráfico entre las
      diferentes subredes será enrutado a través de un router con soporte VLAN trunk 802.1q.</para>

    <para>Las VLANs y subredes IP se describen en la siguiente tabla:</para>

    <table>
      <title>VLANs y subredes IP</title>

      <tgroup cols="3">
        <colspec />

        <colspec align="center" />

        <thead>
          <row>
            <entry align="center">VLAN</entry>

            <entry align="center">Descripción</entry>

            <entry align="center">Subred IP</entry>
          </row>
        </thead>

        <tbody>
          <row>
            <entry>100</entry>

            <entry>Administración Routers</entry>

            <entry>192.168.100.0/24</entry>
          </row>

          <row>
            <entry>110</entry>

            <entry>Administración switches</entry>

            <entry>192.168.110.0/24</entry>
          </row>

          <row>
            <entry>120</entry>

            <entry>Red Servidores</entry>

            <entry>192.168.120.0/24</entry>
          </row>

          <row>
            <entry>130</entry>

            <entry>Red PCs e Impresoras</entry>

            <entry>192.168.130.0/24</entry>
          </row>

          <row>
            <entry>140</entry>

            <entry>Red equipo VoIP</entry>

            <entry>192.168.140.0/24</entry>
          </row>

          <row>
            <entry>150</entry>

            <entry>Red WIFI</entry>

            <entry>192.168.150.0/24&nbsp;</entry>
          </row>
        </tbody>
      </tgroup>
    </table>

    <para>La separación lógica basada en VLANs se realiza en el switch de nombre
      <emphasis role="bold">switch01</emphasis> de marca y modelo Aruba Instant On 1930, en la
      siguiente tabla se muestra su descripción:</para>

    <table>
      <title>Switch administrable</title>

      <tgroup cols="5">
        <colspec />

        <colspec />

        <thead>
          <row>
            <entry align="center">Nombre</entry>

            <entry align="center">Modelo</entry>

            <entry align="center">MAC Address</entry>

            <entry align="center">Dirección IP</entry>

            <entry align="center">Ubicación</entry>
          </row>
        </thead>

        <tbody>
          <row>
            <entry>switch01.example.com</entry>

            <entry>Aruba Instant On 1930</entry>

            <entry>0024-7386-9685</entry>

            <entry>192.168.110.1</entry>

            <entry>SITE01, RACK014</entry>
          </row>
        </tbody>
      </tgroup>
    </table>

    <para>El puerto GE1/0/1 del switch SWITCH01 esta configurado en modo hybrido trunk 802.1p
      para las VLANs 100, 110, 120, 130 y 140.</para>

    <para>El tráfico entre las VLANs será controlado a través de un Router GNU/Linux que está
      conectado al switch en el puerto GE1/0/1 a través de una interfaz Ethernet Gigabit, dicha
      interfaz también esta configurada en modo trunk 802.1q.</para>
  </section>

  <section>
    <title>Configuración de VLANs y puertos en Switch administrable Aruba</title>

    <para>En esta sección se describe brevemente la configuración del switch en respecto a
      las VLANs y los puertos, de acuerdo a los requerimientos se crearon las siguientes VLANs:</para>

    <table>
      <title>Virtual LANs</title>

      <tgroup cols="2">
        <colspec align="center" />

        <thead>
          <row>
            <entry align="center">VLAN ID</entry>

            <entry align="center">Descripción</entry>
          </row>
        </thead>

        <tbody>
          <row>
            <entry>1</entry>

            <entry>VLAN 0001</entry>
          </row>

          <row>
            <entry>100</entry>

            <entry>VLAN ROUTING</entry>
          </row>

          <row>
            <entry>110</entry>

            <entry>VLAN SWITCH</entry>
          </row>

          <row>
            <entry>120</entry>

            <entry>VLAN SERVERS</entry>
          </row>

          <row>
            <entry>130</entry>

            <entry>VLAN PCS</entry>
          </row>

          <row>
            <entry>140</entry>

            <entry>VLAN VOIP</entry>
          </row>

          <row>
            <entry>150</entry>

            <entry>VLAN WIFI</entry>
          </row>
        </tbody>
      </tgroup>
    </table>

    <para>La asignación de puertos a VLAN se describe en la siguiente tabla:</para>

    <table>
      <title>VLANs y puertos</title>

      <tgroup cols="4">
        <colspec align="center" />

        <thead>
          <row>
            <entry align="center">VLAN ID</entry>

            <entry align="center">Descripción</entry>

            <entry align="center">Miembros sin etiquetas</entry>

            <entry align="center">Miembros etiquetados</entry>
          </row>
        </thead>

        <tbody>
          <row>
            <entry>100</entry>

            <entry>VLAN ROUTING</entry>

            <entry></entry>

            <entry>GE1/0/1</entry>
          </row>

          <row>
            <entry>110</entry>

            <entry>VLAN SWITCH</entry>

            <entry></entry>

            <entry>GE1/0/1</entry>
          </row>

          <row>
            <entry>120</entry>

            <entry>VLAN SERVERS</entry>

            <entry>GE1/0/9-GE1/0/16</entry>

            <entry>GE1/0/1</entry>
          </row>

          <row>
            <entry>130</entry>

            <entry>VLAN PCS</entry>

            <entry>GE1/0/17-GE1/0/24</entry>

            <entry>GE1/0/1</entry>
          </row>

          <row>
            <entry>140</entry>

            <entry>VLAN VOIP</entry>

            <entry></entry>

            <entry>GE1/0/1,GE1/0/17-GE1/0/24</entry>
          </row>

          <row>
            <entry>150</entry>

            <entry>VLAN WIFI</entry>

            <entry></entry>

            <entry>GE1/0/8</entry>
          </row>
        </tbody>
      </tgroup>
    </table>

    <para>La VLAN de administración o <foreignphrase>VLAN Interfaz</foreignphrase> es una VLAN
    que se usa para acceder a la interfaz de administración del switch. Se asigno la
    <emphasis>VLAN 110</emphasis> al puerto <emphasis>GE1/0/1</emphasis> y se le asignó la
    dirección IP 192.168.100.1.</para>

    <para>Guarde y respalde la configuración actual.</para>
  </section>

  <section>
    <title>Configurando los requerimientos para interfaces VLAN en GNU/Linux</title>

    <para>Para configurar interfaces VLAN 802.1q debe ejecutar un kernel con soporte VLAN 802.1q,
      una forma de saber si el kernel que estamos ejecutando incluye el soporte del protocolo
      802.1q busquemos la etiqueta VLAN_8021Q en l archivo de configuración del kernel.</para>

    <screen># grep CONFIG_VLAN_8021Q /boot/config-`uname -r`
CONFIG_VLAN_8021Q=<emphasis role="bold">m</emphasis></screen>

    <para>Si aparece como modulo debemos cargarlo manualmente con el comando
      <command>modprobe</command>:</para>

    <screen># modprobe 8021q</screen>

    <para>Al cargar el modulo registra un evento de kernel que puede ser visto
    con <command>dmesg</command>:</para>

    <screen># dmesg | grep -i 802.1q
[ 1801.171046] 802.1Q VLAN Support v1.8 Ben Greear &lt;greearb@candelatech.com&gt;</screen>

    <para>El mensaje anterior nos indica que el soporte de VLAN esta disponible en el sistema,
      también puede verificar si el módulo en realidad esta cargado usando el comando
      <command>lsmod</command>.</para>

    <screen># lsmod | grep 8021q
8021q                  22168  0</screen>

    <para>Cuando se carga el modulo del kernel 8021q se crea el archivo de parámetros del kernel
      <filename>/proc/net/vlan/config</filename>, el cual luce así:</para>

    <screen># cat /proc/net/vlan/config
VLAN Dev name    | VLAN ID
Name-Type: VLAN_NAME_TYPE_RAW_PLUS_VID_NO_PAD</screen>

    <para>En el directorio <filename>/proc/net/vlan/</filename>habrá un archivo de para cada VLAN
    creada que tendrá información como el VLAN ID, estadísticas y otros.</para>

    <para>Para asegurarse de que el modulo 8021q sea cargado automáticamente al inicio del
      sistema agreguelo al archivo <filename>/etc/modules</filename>, por ejemplo:</para>

    <screen># echo 8021q &gt;&gt; /etc/modules</screen>

    <para>El sistema también debe contar con la herramienta (<userinput>userspace</userinput>)
    de configuración de interfaces VLAN <command>vconfig</command>, en Debian/Ubuntu se instala
    con el paquete <emphasis>vlan</emphasis>, el cual no viene en una instalación de Debian/Ubuntu
    por defecto, por lo que hay que instalarlo manualmente.</para>

    <screen># apt-get update &amp;&amp; apt-get install vlan</screen>

    <para>En la siguiente sección veremos como crear las interfaces VLAN en la interfaz de red
      eth1, las interfaces VLAN básicamente son subinterfaces de la interfaz física o raw
      eth1.</para>
  </section>

  <section>
    <title>Configuración de interfaz VLAN 802.1q en Ubuntu Server</title>

    <para>Como mencionamos arriba, para configurar una o más interfaz VLAN 802.1q en sistemas
      GNU/Linux se requiere de una interfaz Ethernet con soporte VLAN 802.1q, en especifico
      el driver con soporte VLAN, las interfaces VLAN en Linux son algo así como subinterfaces
      asociadas a una interfaz <emphasis>RAW</emphasis>, en este caso la interfaz física
      Ethernet.</para>

    <para>La configuración de las VLANs en el servidor Ubuntu Server las vamos a realizar en
      un equipo con las siguientes especificaciones:</para>

    <table>
      <title>Especificaciones Servidor Linux</title>

      <tgroup cols="2">
        <colspec align="center" />

        <thead>
          <row>
            <entry align="center">Componente</entry>

            <entry align="center">Descripción</entry>
          </row>
        </thead>

        <tbody>
          <row>
            <entry>CPU</entry>

            <entry>AMD Athlon(tm) 64 X2 Dual Core Processor 5000+</entry>
          </row>

          <row>
            <entry>Memoria</entry>

            <entry>1GB</entry>
          </row>

          <row>
            <entry>Red WAN (eth0)</entry>

            <entry>Gigabit Ethernet nVidia MCP55</entry>
          </row>

          <row>
            <entry>Red LAN (eth1)</entry>

            <entry>Broadcom NetXtreme BCM5721 Gigabit Ethernet PCI
            Express</entry>
          </row>
        </tbody>
      </tgroup>
    </table>

    <note>
      <para>El driver de la interfaz de red debe soportar el soporte VLAN, actualmente la mayoría
        de interfaces de red en Linux soportan VLAN.</para>
    </note>

    <para>Aunque es posible configurar las VLANs y las interfaces de red virtuales de forma
      manual usando los comandos <command>vconfig</command>,
      <command>ifconfig</command> o <command>ip</command> en este documento vamos a usar las
      herramientas de configuración de red del sistema operativo, en distribuciones Debian/Ubuntu
      podemos configurar las interfaces VLAN desde el archivo de configuración
    <filename>/etc/network/interfaces</filename>.</para>

    <para>Edite el archivo <filename>/etc/network/intefaces</filename> para definir las VLANs
    y las direcciones IP asociadas a cada interfaz virtual:</para>

    <screen># vim /etc/network/interfaces</screen>

    <para>Agreguemos las siguientes líneas para configurar la interfaz física eth1 en modo
      <option>manual</option> y definimos las interfaces de red virtuales VLAN asociadas a
      la interfaz <emphasis>raw</emphasis> eth1.</para>

    <programlisting># Interfaz VLAN 802.1q (Trunk)
auto eth1
<emphasis role="bold">iface eth1 inet manual</emphasis>

# Interfaz VLAN 100 - ROUTING
auto vlan100
<emphasis role="bold">iface vlan100 inet static</emphasis>
  address 192.168.100.254
  netmask 255.255.255.0
  vlan_raw_device <emphasis role="bold">eth1</emphasis>

# Interfaz VLAN 110 - SWITCH
auto vlan110
<emphasis role="bold">iface vlan110 inet static</emphasis>
  address 192.168.110.254
  netmask 255.255.255.0
  vlan_raw_device <emphasis role="bold">eth1</emphasis>

# Interfaz VLAN 120 - SERVERS
auto vlan120
<emphasis role="bold">iface vlan120 inet static</emphasis>
  address 192.168.120.254
  netmask 255.255.255.0
  vlan_raw_device <emphasis role="bold">eth1</emphasis>

# Interfaz VLAN 130 - PCS
auto vlan130
<emphasis role="bold">iface vlan130 inet static</emphasis>
 address 192.168.130.254
 netmask 255.255.255.0
 vlan_raw_device <emphasis role="bold">eth1</emphasis>

# Interfaz VLAN 140 - VOIP
auto vlan140
<emphasis role="bold">iface vlan140 inet static</emphasis>
 address 192.168.140.254
 netmask 255.255.255.0
 vlan_raw_device <emphasis role="bold">eth1</emphasis>

# Interfaz VLAN 150 - WIFI
auto vlan150
<emphasis role="bold">iface vlan150 inet static</emphasis>
 address 192.168.150.254
 netmask 255.255.255.0
 vlan_raw_device <emphasis role="bold">eth1
</emphasis></programlisting>

    <note>
      <para>Cuando se configura una interfaz en modo manual no se requiere definir una
        dirección IP estática.</para>
    </note>

    <para>Active las interfaces VLAN de forma independiente usando el comando
      <command>ifup</command>:</para>

    <screen># ifup vlan100
Set name-type for VLAN subsystem. Should be visible in /proc/net/vlan/config
Added VLAN with VID == 100 to IF -:eth1:-

# ifup vlan110
Set name-type for VLAN subsystem. Should be visible in /proc/net/vlan/config
Added VLAN with VID == 110 to IF -:eth1:-

# ifup vlan120
Set name-type for VLAN subsystem. Should be visible in /proc/net/vlan/config
Added VLAN with VID == 120 to IF -:eth1:-

# ifup vlan130
Set name-type for VLAN subsystem. Should be visible in /proc/net/vlan/config
Added VLAN with VID == 130 to IF -:eth1:-

# ifup vlan140
Set name-type for VLAN subsystem. Should be visible in /proc/net/vlan/config
Added VLAN with VID == 140 to IF -:eth1:-

# ifup vlan150
Set name-type for VLAN subsystem. Should be visible in /proc/net/vlan/config
Added VLAN with VID == 150 to IF -:eth1:-</screen>

    <para>Para desactivar las interfaces VLAN puede usar el comando
    <command>ifdown</command>, por ejemplo:</para>

    <screen># ifdown vlan150</screen>

    <para>Para reiniciar una interfaz se recomienda que utilice:</para>

    <screen># ifdown vlan150 &amp;&amp; ifup vlan150</screen>

    <para>Cuando se crean las VLANs podemos ver la siguiente información en el archivo de
      parámetros del kernel <filename>/proc/net/vlan/config</filename>:</para>

    <screen># cat /proc/net/vlan/config
VLAN Dev name    | VLAN ID
Name-Type: VLAN_NAME_TYPE_PLUS_VID_NO_PAD
vlan100        | 100  | eth1
vlan110        | 110  | eth1
vlan120        | 120  | eth1
vlan130        | 130  | eth1
vlan140        | 140  | eth1
vlan150        | 150  | eth1
</screen>

    <para>Para ver más información de las interfaces virtuales vea el archivo correspondiente
      a la VLAN en el directorio <filename>/proc/net/vlan</filename>, por ejemplo:</para>

    <screen># cat /proc/net/vlan/vlan100
vlan100  VID: 100        REORDER_HDR: 1  dev-&gt;priv_flags: 1
         total frames received            0
          total bytes received            0
      Broadcast/Multicast Rcvd            0

      total frames transmitted           42
       total bytes transmitted        12112
            total headroom inc            0
           total encap on xmit           42
Device: eth1
INGRESS priority mappings: 0:0  1:0  2:0  3:0  4:0  5:0  6:0 7:0
 EGRESS priority mappings:

# cat /proc/net/vlan/vlan110
vlan110  VID: 110        REORDER_HDR: 1  dev-&gt;priv_flags: 1
         total frames received            0
          total bytes received            0
      Broadcast/Multicast Rcvd            0

      total frames transmitted           34
       total bytes transmitted        11119
            total headroom inc            0
           total encap on xmit           34
Device: eth1
INGRESS priority mappings: 0:0  1:0  2:0  3:0  4:0  5:0  6:0 7:0
 EGRESS priority mappings:

# cat /proc/net/vlan/vlan120
vlan120  VID: 120        REORDER_HDR: 1  dev-&gt;priv_flags: 1
         total frames received            0
          total bytes received            0
      Broadcast/Multicast Rcvd            0

      total frames transmitted           37
       total bytes transmitted        11621
            total headroom inc            0
           total encap on xmit           37
Device: eth1
INGRESS priority mappings: 0:0  1:0  2:0  3:0  4:0  5:0  6:0 7:0
 EGRESS priority mappings:

# cat /proc/net/vlan/vlan130
vlan130  VID: 130        REORDER_HDR: 1  dev-&gt;priv_flags: 1
         total frames received            0
          total bytes received            0
      Broadcast/Multicast Rcvd            0

      total frames transmitted           35
       total bytes transmitted        11286
            total headroom inc            0
           total encap on xmit           35
Device: eth1
INGRESS priority mappings: 0:0  1:0  2:0  3:0  4:0  5:0  6:0 7:0
 EGRESS priority mappings:

# cat /proc/net/vlan/vlan140
vlan140  VID: 140        REORDER_HDR: 1  dev-&gt;priv_flags: 1
         total frames received            0
          total bytes received            0
      Broadcast/Multicast Rcvd            0

      total frames transmitted           36
       total bytes transmitted        11607
            total headroom inc            0
           total encap on xmit           36
Device: eth1
INGRESS priority mappings: 0:0  1:0  2:0  3:0  4:0  5:0  6:0 7:0
 EGRESS priority mappings:

# cat /proc/net/vlan/vlan150
vlan150  VID: 150        REORDER_HDR: 1  dev-&gt;priv_flags: 1
         total frames received            0
          total bytes received            0
      Broadcast/Multicast Rcvd            0

      total frames transmitted           25
       total bytes transmitted         4587
            total headroom inc            0
           total encap on xmit           25
Device: eth1
INGRESS priority mappings: 0:0  1:0  2:0  3:0  4:0  5:0  6:0 7:0
 EGRESS priority mappings:
</screen>

    <para>Puede usar los comandos <command>ifconfig</command> o <command>ip</command> para
    ver la información de las interfaces de red físicas y virtuales y la dirección IP asignada,
    por ejemplo:</para>

    <screen>eth1      Link encap:Ethernet  direcciónHW 00:e0:29:5b:ae:a4
          Dirección inet6: fe80::2e0:29ff:fe5b:aea4/64 Alcance:Enlace
          ACTIVO DIFUSIÓN FUNCIONANDO MULTICAST  MTU:1500  Métrica:1
          Paquetes RX:0 errores:0 perdidos:0 overruns:0 frame:0
          Paquetes TX:151 errores:0 perdidos:0 overruns:0 carrier:0
          colisiones:0 long.colaTX:1000
          Bytes RX:0 (0.0 B)  TX bytes:23648 (23.6 KB)
          Interrupción:21 Dirección base: 0xe800

vlan100   Link encap:Ethernet  direcciónHW 00:e0:29:5b:ae:a4
          Direc. inet:192.168.100.254  Difus.:192.168.100.255  Másc:255.255.255.0
          Dirección inet6: fe80::2e0:29ff:fe5b:aea4/64 Alcance:Enlace
          ACTIVO DIFUSIÓN FUNCIONANDO MULTICAST  MTU:1500  Métrica:1
          Paquetes RX:0 errores:0 perdidos:0 overruns:0 frame:0
          Paquetes TX:29 errores:0 perdidos:0 overruns:0 carrier:0
          colisiones:0 long.colaTX:0
          Bytes RX:0 (0.0 B)  TX bytes:4632 (4.6 KB)

vlan110   Link encap:Ethernet  direcciónHW 00:e0:29:5b:ae:a4
          Direc. inet:192.168.110.254  Difus.:192.168.110.255  Másc:255.255.255.0
          Dirección inet6: fe80::2e0:29ff:fe5b:aea4/64 Alcance:Enlace
          ACTIVO DIFUSIÓN FUNCIONANDO MULTICAST  MTU:1500  Métrica:1
          Paquetes RX:0 errores:0 perdidos:0 overruns:0 frame:0
          Paquetes TX:29 errores:0 perdidos:0 overruns:0 carrier:0
          colisiones:0 long.colaTX:0
          Bytes RX:0 (0.0 B)  TX bytes:4632 (4.6 KB)

vlan120   Link encap:Ethernet  direcciónHW 00:e0:29:5b:ae:a4
          Direc. inet:192.168.120.254  Difus.:192.168.120.255  Másc:255.255.255.0
          Dirección inet6: fe80::2e0:29ff:fe5b:aea4/64 Alcance:Enlace
          ACTIVO DIFUSIÓN FUNCIONANDO MULTICAST  MTU:1500  Métrica:1
          Paquetes RX:0 errores:0 perdidos:0 overruns:0 frame:0
          Paquetes TX:29 errores:0 perdidos:0 overruns:0 carrier:0
          colisiones:0 long.colaTX:0
          Bytes RX:0 (0.0 B)  TX bytes:4632 (4.6 KB)

vlan130   Link encap:Ethernet  direcciónHW 00:e0:29:5b:ae:a4
          Direc. inet:192.168.130.254  Difus.:192.168.130.255  Másc:255.255.255.0
          Dirección inet6: fe80::2e0:29ff:fe5b:aea4/64 Alcance:Enlace
          ACTIVO DIFUSIÓN FUNCIONANDO MULTICAST  MTU:1500  Métrica:1
          Paquetes RX:0 errores:0 perdidos:0 overruns:0 frame:0
          Paquetes TX:29 errores:0 perdidos:0 overruns:0 carrier:0
          colisiones:0 long.colaTX:0
          Bytes RX:0 (0.0 B)  TX bytes:4632 (4.6 KB)

vlan140   Link encap:Ethernet  direcciónHW 00:e0:29:5b:ae:a4
          Direc. inet:192.168.140.254  Difus.:192.168.140.255  Másc:255.255.255.0
          Dirección inet6: fe80::2e0:29ff:fe5b:aea4/64 Alcance:Enlace
          ACTIVO DIFUSIÓN FUNCIONANDO MULTICAST  MTU:1500  Métrica:1
          Paquetes RX:0 errores:0 perdidos:0 overruns:0 frame:0
          Paquetes TX:29 errores:0 perdidos:0 overruns:0 carrier:0
          colisiones:0 long.colaTX:0
          Bytes RX:0 (0.0 B)  TX bytes:4632 (4.6 KB)

vlan150   Link encap:Ethernet  direcciónHW 00:e0:29:5b:ae:a4
          Direc. inet:192.168.150.254  Difus.:192.168.150.255  Másc:255.255.255.0
          Dirección inet6: fe80::2e0:29ff:fe5b:aea4/64 Alcance:Enlace
          ACTIVO DIFUSIÓN FUNCIONANDO MULTICAST  MTU:1500  Métrica:1
          Paquetes RX:0 errores:0 perdidos:0 overruns:0 frame:0
          Paquetes TX:25 errores:0 perdidos:0 overruns:0 carrier:0
          colisiones:0 long.colaTX:0
          Bytes RX:0 (0.0 B)  TX bytes:4587 (4.5 KB)
</screen>

    <para>También puede usar el comando <command>ip</command> para ver las
    interfaces:</para>

    <screen># ip link list
3: <emphasis role="bold">eth1</emphasis>: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc pfifo_fast state UNKNOWN qlen 1000
    link/ether 00:e0:29:5b:ae:a4 brd ff:ff:ff:ff:ff:ff
4: <emphasis role="bold">vlan100@eth1</emphasis>: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc noqueue state UP
    link/ether 00:e0:29:5b:ae:a4 brd ff:ff:ff:ff:ff:ff
5: <emphasis role="bold">vlan110@eth1</emphasis>: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc noqueue state UP
    link/ether 00:e0:29:5b:ae:a4 brd ff:ff:ff:ff:ff:ff
6: <emphasis role="bold">vlan120@eth1</emphasis>: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc noqueue state UP
    link/ether 00:e0:29:5b:ae:a4 brd ff:ff:ff:ff:ff:ff
7: <emphasis role="bold">vlan130@eth1</emphasis>: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc noqueue state UP
    link/ether 00:e0:29:5b:ae:a4 brd ff:ff:ff:ff:ff:ff
8: <emphasis role="bold">vlan140@eth1</emphasis>: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc noqueue state UP
    link/ether 00:e0:29:5b:ae:a4 brd ff:ff:ff:ff:ff:ff
9: <emphasis role="bold">vlan150@eth1</emphasis>: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc noqueue state UP
    link/ether 00:e0:29:5b:ae:a4 brd ff:ff:ff:ff:ff:ff
</screen>

    <note>
      <para>En esta salida es posible ver la interfaz física a la que esta
      amarrada la VLAN.</para>
    </note>

    <para>Y para ver las direcciones IP asignadas a las interfaces
    VLAN:</para>

    <screen># ip addr list
3: <emphasis role="bold">eth1</emphasis>: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc pfifo_fast state UNKNOWN qlen 1000
    link/ether 00:e0:29:5b:ae:a4 brd ff:ff:ff:ff:ff:ff
    inet6 fe80::2e0:29ff:fe5b:aea4/64 scope link
       valid_lft forever preferred_lft forever
4: <emphasis role="bold">vlan100@eth1</emphasis>: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc noqueue state UP
    link/ether 00:e0:29:5b:ae:a4 brd ff:ff:ff:ff:ff:ff
    inet <emphasis role="bold">192.168.100.254/24</emphasis> brd 192.168.100.255 scope global vlan100
    inet6 fe80::2e0:29ff:fe5b:aea4/64 scope link
       valid_lft forever preferred_lft forever
5: <emphasis role="bold">vlan110@eth1</emphasis>: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc noqueue state UP
    link/ether 00:e0:29:5b:ae:a4 brd ff:ff:ff:ff:ff:ff
    inet <emphasis role="bold">192.168.110.254/24</emphasis> brd 192.168.110.255 scope global vlan110
    inet6 fe80::2e0:29ff:fe5b:aea4/64 scope link
       valid_lft forever preferred_lft forever
6: <emphasis role="bold">vlan120@eth1</emphasis>: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc noqueue state UP
    link/ether 00:e0:29:5b:ae:a4 brd ff:ff:ff:ff:ff:ff
    inet <emphasis role="bold">192.168.120.254/24</emphasis> brd 192.168.120.255 scope global vlan120
    inet6 fe80::2e0:29ff:fe5b:aea4/64 scope link
       valid_lft forever preferred_lft forever
7: <emphasis role="bold">vlan130@eth1</emphasis>: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc noqueue state UP
    link/ether 00:e0:29:5b:ae:a4 brd ff:ff:ff:ff:ff:ff
    inet <emphasis role="bold">192.168.130.254/24</emphasis> brd 192.168.130.255 scope global vlan130
    inet6 fe80::2e0:29ff:fe5b:aea4/64 scope link
       valid_lft forever preferred_lft forever
8: <emphasis role="bold">vlan140@eth1</emphasis>: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc noqueue state UP
    link/ether 00:e0:29:5b:ae:a4 brd ff:ff:ff:ff:ff:ff
    inet <emphasis role="bold">192.168.140.254/24</emphasis> brd 192.168.140.255 scope global vlan140
    inet6 fe80::2e0:29ff:fe5b:aea4/64 scope link
       valid_lft forever preferred_lft forever
9: <emphasis role="bold">vlan150@eth1</emphasis>: &lt;BROADCAST,MULTICAST,UP,LOWER_UP&gt; mtu 1500 qdisc noqueue state UP
    link/ether 00:e0:29:5b:ae:a4 brd ff:ff:ff:ff:ff:ff
    inet <emphasis role="bold">192.168.150.254/24</emphasis> brd 192.168.150.255 scope global vlan150
    inet6 fe80::2e0:29ff:fe5b:aea4/64 scope link
       valid_lft forever preferred_lft forever
</screen>

    <note>
      <para>La interfaz física eth1 no tiene una dirección IP asignada ya que para este
        escenario no se necesita.</para>
    </note>

    <para>Veamos la tabla de rutas en el servidor router:</para>

    <screen># route -n
Tabla de rutas IP del núcleo
Destino         Pasarela        Genmask         Indic Métric Ref    Uso Interfaz
1.1.1.2         0.0.0.0         255.255.255.0   U     0      0        0 eth0
192.168.100.0   0.0.0.0         255.255.255.0   U     0      0        0 vlan100
192.168.110.0   0.0.0.0         255.255.255.0   U     0      0        0 vlan110
192.168.120.0   0.0.0.0         255.255.255.0   U     0      0        0 vlan120
192.168.130.0   0.0.0.0         255.255.255.0   U     0      0        0 vlan130
192.168.140.0   0.0.0.0         255.255.255.0   U     0      0        0 vlan140
192.168.150.0   0.0.0.0         255.255.255.0   U     0      0        0 vlan150
0.0.0.0         1.1.1.1         0.0.0.0         UG    100    0        0 eth0</screen>

    <important>
      <para>De ahora en adelante, tendrá que configurar las interfaces virtuales, es decir,
        con las subinterfaces no la física eth1, es decir las interfaces
        <emphasis>vlanXXX</emphasis>,</para>
    </important>

    <para>Para convertir al servidor en un router debe permitir el reenvío de paquetes IP entre
      las diferentes interfaces de red, en especifico, debe habilitar el soporte
      <foreignphrase>IP Forwarding</foreignphrase> en el kernel, para controlar el IP
      forwarding en el sistema cambie el estado del archivo
      <filename>/proc/sys/net/ipv4/ip_forward</filename>, por ejemplo:</para>

    <screen># echo 1 &gt; /proc/sys/net/ipv4/ip_forward</screen>

    <para>Verifique el estado del IP forwarding:</para>

    <screen># cat /proc/sys/net/ipv4/ip_forward
1</screen>

    <important>
      <para>Para hacer persistente este cambio agregue la línea <emphasis
      role="bold">net.ipv4.ip_forward=1</emphasis> al archivo
      <filename>/etc/sysctl.conf</filename>.</para>
    </important>

    <para>Si desea configurar una interfaz debe ser sobre la interfaz vlanXXX, o si desea
      analizar el tráfico con alguna herramienta como <command>tcpdump</command>, tshark o
      wireshark siga las siguientes recomendaciones, por ejemplo usando tcpdump:</para>

    <para>Para analizar el tráfico dentro de una VLAN en el router use:</para>

    <screen># tcpdump -nvi vlan130</screen>

    <para>Para analizar el tráfico de todas las VLANs use:</para>

    <screen># tcpdump -i eth1</screen>

    <para>En la siguiente sección veremos algunas pruebas de conectividad entre diferentes
      dispositivos conectados en diferentes VLANs.</para>
  </section>

  <section>
    <title>Pruebas de conectividad entre VLANs</title>

    <para>Realice pruebas de conectividad usando el comando ping, primero pruebe con tráfico
      originado en el router hacía algún equipo en las diferentes redes:</para>

    <para>Haga un ping desde el router hacía el switch01:</para>

    <screen># ping -c 3 192.168.110.1</screen>

    <para>ping router-&gt;server</para>

    <para>ping router-&gt;pc</para>

    <para>Haga un ping desde el router hacía el IP-PBX:</para>

    <screen># ping -c 3 192.168.140.1</screen>

    <para>Ahora verifique el tráfico entre las PCs e Impresoras y los servidores, en caso de que
      este permitido, realizar el ping desde el servidor a una PC (ejemplo print server en
      red pcs).</para>

    <para>ping pc-&gt;server</para>

    <para>pinc server-&gt;pc</para>

    <para>Ahora pruebe comunicación entre el equipo de administración del IP-PBX.</para>

    <para>ping pc-&gt;pbx</para>

    <para>ping phone-&gt;pbx</para>

    <para>Pruebas desde la red Inalámbrica:</para>

    <para>ping wifi-&gt;XXX</para>

    <para>Si no ha creado reglas de filtrado de paquetes entre las VLANs entonces no deberá de
      tener problemas en las pruebas de conectividad.</para>
  </section>

  <section>
    <title>Soporte VLAN Routing, Firewalling, QoS y otros en GNU/Linux</title>

    <para>Como mencione al inicio del documento, los sistemas GNU/Linux incluyen el soporte a
      nivel kernel 2.6+ y las herramientas de usuario para convertir un servidor GNU/Linux en
      un potente router estable, seguro y que de un buen desempeño ya que podemos ejecutar un
      router con GNU/Linux en equipos x86 tanto en 32 como 64-bit ya sea Intel x_86_64 o AMD64,
      ya sean routers pequeños con procesadores atom o geode, o routers de alto desempeño
      y disponibilidad con servidores grandes con procesadores 2 quad-core y 16GB de RAM y
      fuentes de poder redundantes.</para>

    <para>Algunas de las funcionalidades básicas de Networking que podemos realizar en un router
      GNU/Linux son:</para>

    <itemizedlist>
      <listitem>
        <para>Basic Routing: Static routing.</para>
      </listitem>

      <listitem>
        <para>Packet Filtering: Static and Stateful Packet Filtering.</para>
      </listitem>

      <listitem>
        <para>Quality of service (QoS).</para>
      </listitem>

      <listitem>
        <para>Ethernet Bridges.</para>
      </listitem>
    </itemizedlist>

    <para>En lo personal recomiendo la herramienta <ulink
    url="http://shorewall.net/">Shorewall</ulink> para realizar la configuración de sistemas
    de filtrado de paquetes Firewall tanto para routers de VLANs como firewalls con conexiones
    a Internet, permite filtrado de paquetes avanzado basado en zonas, integración de reglas de
    enrutado, Balanceo de cargas entre múltiples enlaces de Internet, QoS y muchas otras
    funcionalidades.</para>

    <para>Algunas otras funcionalidades de Networking avanzadas son:</para>

    <itemizedlist>
      <listitem>
        <para>Ethernet Channel Bonding.</para>
      </listitem>

      <listitem>
        <para>Router Cluster: VRRP.</para>
      </listitem>

      <listitem>
        <para>IDS/IPS: Snort.</para>
      </listitem>

      <listitem>
        <para>Virtual Private Network (VPN).</para>
      </listitem>

      <listitem>
        <para>Policy Routing.</para>
      </listitem>

      <listitem>
        <para>Dynamic Routing: RIP, OSPF, BGP.</para>
      </listitem>

      <listitem>
        <para>WAN Load Balancing: Multi WAN.</para>
      </listitem>
    </itemizedlist>

    <para>Una distribución especializada para sistemas de red es <ulink
    url="http://www.vyatta.org/">Vyatta</ulink>, basada en Debian soporta todas las
    funcionalidades básicas y avanzadas antes mencionadas, muy recomendable para aquellos que
    vienen del mundo Cisco.</para>

    <para>Otro punto clave de las capacidades de Networking de sistemas GNU/Linux es que puede
      ser implementado tanto en sistemas físicos en las varias arquitecturas de hardware
      soportadas por el kernel Linux y también puede operar en entornos virtualizados como Xen,
      KVM, VirtualBox, VMware y hasta HyperV, en ambos casos para arquitecturas 32 y 64-bit,
      funcionalidades ideales para entornos en la nuble ya sea pública o privada.</para>

    <para>Para aquellos que esten interesados en las capacidades de Networking de Linux es
      importante mencionar que incluso hay soporte de interfaces de comunicación para
      diferentes medios como X.25, frame relay, ADSL y otros,
      <ulink url="http://sangoma.com/">Sangoma</ulink> es un fabricante de tarjetas de este
      tipo con soporte para Linux.</para>

    <para>Para más información se recomienda leer las referencias incluidas al final del
      documento.</para>
  </section>

  <section>
    <title>Recursos adicionales</title>

    <para>Si desea obtener más información sobre los programas y páginas de manual relacionadas
      se aconseja que acceda a los siguientes recursos adicionales.</para>

    <section>
      <title>Sitios web</title>

      <para>En las paginas listadas a continuación encontrará mayor información sobre los
        programas utilizados en este capitulo.</para>

      <itemizedlist>
        <listitem>
          <para><ulink
          url="http://grouper.ieee.org/groups/802/1/pages/802.1Q.html">http://grouper.ieee.org/groups/802/1/pages/802.1Q.html</ulink>
          - 802.1Q - Virtual LANs</para>
        </listitem>

        <listitem>
          <para><ulink
          url="http://www.candelatech.com/~greear/vlan.html">http://www.candelatech.com/~greear/vlan.html</ulink>
          - 802.1Q VLAN implementation for Linux</para>
        </listitem>

        <listitem>
          <para><ulink
          url="http://www.linuxjournal.com/article/7268">http://www.linuxjournal.com/article/7268</ulink>
          - VLANs on Linux</para>
        </listitem>

        <listitem>
          <para><ulink
          url="http://www.linuxhorizon.ro/vlans.html">http://www.linuxhorizon.ro/vlans.html</ulink>
          - VLAN - Virtual Local Area Network</para>
        </listitem>

        <listitem>
          <para><ulink
          url="http://linux-ip.net/html/ether-vlan.html">http://linux-ip.net/html/ether-vlan.html</ulink>
          - Connecting to an Ethernet 802.1q VLAN</para>
        </listitem>

        <listitem>
          <para><ulink
          url="http://www.linuxfoundation.org/collaborate/workgroups/networking/vlan">http://www.linuxfoundation.org/collaborate/workgroups/networking/vlan</ulink>
          - The Linux Fundation - VLAN</para>
        </listitem>

        <listitem>
          <para><ulink
          url="http://linox.be/wiki/index.php?n=Linux.VlanOnDebian">http://linox.be/wiki/index.php?n=Linux.VlanOnDebian</ulink>
          - Vlan On Debian</para>
        </listitem>

        <listitem>
          <para><ulink
          url="http://www.firewall.cx/vlans-routing.php">http://www.firewall.cx/vlans-routing.php</ulink>
          - InterVLAN Routing</para>
        </listitem>

        <listitem>
          <para><ulink
          url="http://www.cyberciti.biz/tips/howto-configure-linux-virtual-local-area-network-vlan.html">http://www.cyberciti.biz/tips/howto-configure-linux-virtual-local-area-network-vlan.html</ulink>
          - Howto: Configure Linux Virtual Local Area Network (VLAN) (REDHAT
          WAY)</para>
        </listitem>

        <listitem>
          <para><ulink url="http://lartc.org/">http://lartc.org</ulink> -
          Linux Advanced Routing &amp; Traffic Control</para>
        </listitem>

        <listitem>
          <para><ulink
          url="http://www.policyrouting.org/PolicyRoutingBook/">http://www.policyrouting.org/PolicyRoutingBook/</ulink>
          - Policy Routing With Linux by Matthew G. Marsh</para>
        </listitem>

        <listitem>
          <para><ulink
          url="http://shorewall.net/">http://shorewall.net</ulink> - Shorewall
          Firewall</para>
        </listitem>

        <listitem>
          <para><ulink
          url="http://www.vyatta.com/">http://www.vyatta.com</ulink> -
          Vyatta</para>
        </listitem>

        <listitem>
          <para><ulink url="http://sangoma.com">http://sangoma.com</ulink> -
          Sangoma</para>
        </listitem>
      </itemizedlist>

      <para></para>
    </section>

    <section>
      <title>Páginas de manual</title>

      <para>Para conocer más sobre el uso y configuración de los programas utilizados en el
        capitulo, se recomienda leer los manuales relacionados y el contenido de los archivos
        de configuración.</para>

      <itemizedlist>
        <listitem>
          <para>modprobe (8) - program to add and remove modules from the Linux Kernel</para>
        </listitem>

        <listitem>
          <para>lsmod (8) - program to show the status of modules in the Linux Kernel</para>
        </listitem>

        <listitem>
          <para>apt-get (8) - APT package handling utility - - command-line interface</para>
        </listitem>

        <listitem>
          <para>interfaces (5) - network interface configuration for ifup and ifdown</para>
        </listitem>

        <listitem>
          <para>vlan-interfaces (5) - (tema desconocido) - vlan extensions for the interfaces(5)
            file format</para>
        </listitem>

        <listitem>
          <para>ifup (8) - bring a network interface up</para>
        </listitem>

        <listitem>
          <para>ifdown (8) - take a network interface down</para>
        </listitem>

        <listitem>
          <para>ifconfig (8) - configure a network interface</para>
        </listitem>

        <listitem>
          <para>ip (8) - show / manipulate routing, devices, policy routing and tunnels</para>
        </listitem>

        <listitem>
          <para>tcpdump (8) - dump traffic on a network</para>
        </listitem>

        <listitem>
          <para>ping (8) - send ICMP ECHO_REQUEST to network hosts</para>
        </listitem>
      </itemizedlist>
    </section>
  </section>
</article>
